#include "Octree.h"

#include "SurfaceList.h"

Octree::Octree( const SurfaceList *scene ) : Accelerator(scene)
{
    /* TODO
     * Implement the generation of your Acceleration Data Structure (ADS) here.
     * All surfaces that are contained in scene->getSurfaces() need to be
     * considered. However, Planes and Checkboards might need to be handled
     * with an exception, as their AABB is infinitely big, do not span your
     * ADS across infinite space.
     * The generation time of the ADS is not considered for the speed-up factor
     * during raytracing, however the generation time should still be in the
     * realm of interactive speeds (i.e. less than 5s for all given scenes).
     * The Aabb class contains function that could be of use, depending on your
     * ADS and what exact approach you choose.
     */
}

Octree::~Octree()
{ 
    /* TODO
     * Free resources that you requested in the constructor, for example heap
     * memory that you allocated in the constructor by new or malloc needs to
     * have a corresponding delete or free here.
     * If you forget to release resources there will be a memory leak that will
     * result in a deduction of points.
     */
}

Intersection Octree::intersect( Ray ray, float tStart, float tEnd ) const
{
    Intersection intersection;

    /* TODO
     * Implement the intersection of the scene, accelerated by your Acceleration
     * Data Structure (ADS) here.
     * The intersection of a tree should simply be started by rootNode->intersect(...),
     * where a TreeNode recursively intersects the tree, traversing those child nodes
     * whose parent nodes is hit by the ray, thereby pruning parts of the tree that
     * can't be hit by the ray.
     * Traversal of Space Partitions like Uniform Grid usually involve finding the
     * intersection of the ADS bounds, giving you a start and endpoint along the ray,
     * between which the ADS cells need to be efficiently traversed.
     * 
     * Typically Bounding Trees are easy to traverse but hard to create tightly,
     * whereas Space Partitions are easy to create but hard to traverse efficiently.
     * 
     * You can handle Surfaces of the type Planes and Checkerboards with the following
     * exception without inserting them into your ADS:
     * 
     *  for (int i=0; i<hugeSurfaces.size(); ++i)
     *      intersection.combineClosest( hugeSurfaces[i]->intersect(ray, tStart, tEnd) );
     */

    return intersection;
}