#include "Plane.h"

Plane::Plane(Vec4f pPoint, Vec4f pNormal, Shader pShader){
    point = pPoint;
    normal = pNormal;
    shader = pShader;
}

Intersection Plane::intersect(Ray ray, float tStart, float tEnd){
    // Initialize result struct (per default, hasIntersection is false):
    Intersection intersection;

    float f_denominator = normal.dot(ray.direction);

    if (std::abs(f_denominator) < FLT_EPSILON )
        return intersection;

    float t = normal.dot(point - ray.origin) / f_denominator;

    if ( t > tStart && t < tEnd )
    {
        intersection.hasIntersection = true;
        intersection.t = t;
        intersection.hitPoint = ray.evaluate(t);
        intersection.normal = normal;
        intersection.shader = &shader;
    }

    return intersection;
}

Aabb Plane::getAabb() const
{
    return Aabb();
}