// © 2023, CGVR (https://cgvr.informatik.uni-bremen.de/),

#pragma once

#include "src/scene/Surface.h"
#include "Mat4f.h"

class Shader;
class Mesh;

class Triangle : public Surface
{
    bool inited = false;
    Shader shader;
    Vec4f vs[3];
    Vec4f ns[3];
    Aabb aabb;
    void calcAabb();

public:
    Triangle(Vec4f v0, Vec4f v1, Vec4f v2, Vec4f n0, Vec4f n1, Vec4f n2, Shader pShader, Mat4f M);

    virtual Intersection intersect(Ray ray, float tStart, float tEnd) override;

    /** See documentation in parent class 'Surface' */
    virtual Aabb getAabb() const override;
};
